#include "ultrasonic.hpp"

struct usData_t usData[2];

void us_0_isr() {
  if(digitalRead(US_RX_0_PIN)) {
    usData[0].pulseStart = micros();
  } else if(usData[0].rxPending) {
    usData[0].duration   = micros() - usData[0].pulseStart;
    usData[0].rxPending = 0;
    usData[0].newData   = 1;
  }
}

void us_1_isr() {
  if(digitalRead(US_RX_1_PIN)) {
    usData[1].pulseStart = micros();
  } else if(usData[1].rxPending) {
    usData[1].duration   = micros() - usData[1].pulseStart;
    usData[1].rxPending = 0;
    usData[1].newData   = 1;
  }
}

void us_init() {
  attachInterrupt(digitalPinToInterrupt(US_RX_0_PIN), us_0_isr, CHANGE);
  attachInterrupt(digitalPinToInterrupt(US_RX_1_PIN), us_1_isr, CHANGE);
}

void us_transmit() {
  noInterrupts();

  pinMode(US_RX_0_PIN, OUTPUT);
  pinMode(US_RX_1_PIN, OUTPUT);
  pinMode(US_TX_0_PIN, OUTPUT);
  digitalWrite(US_RX_0_PIN, LOW);
  digitalWrite(US_RX_1_PIN, LOW);
  digitalWrite(US_TX_0_PIN, LOW);
  delayMicroseconds(2);
  digitalWrite(US_RX_0_PIN, HIGH);
  digitalWrite(US_RX_1_PIN, HIGH);
  digitalWrite(US_TX_0_PIN, HIGH);
  delayMicroseconds(5);
  digitalWrite(US_RX_0_PIN, LOW);
  digitalWrite(US_RX_1_PIN, LOW);
  digitalWrite(US_TX_0_PIN, LOW);
  pinMode(US_RX_0_PIN, INPUT);
  pinMode(US_RX_1_PIN, INPUT);
  pinMode(US_TX_0_PIN, INPUT);

  interrupts();

  usData[0].rxPending = 1;
  usData[1].rxPending = 1;
} 

long us_get_duration(byte sensor) {
  // check if there is new sensor data
  if(usData[sensor].newData) {
    usData[sensor].newData = 0;
    return usData[sensor].duration;
  } else {
    return usData[sensor].duration;
    //return -1;
  }
}